<?php

	// Dismiss Session
    PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_CAT_REGION_ID',
					'PARAM_CAT_REGION_GLOBAL_ID',
					'PARAM_CAT_REGION_CAT_COUNTRY_ID',
					'PARAM_CAT_REGION_CODE',
					'PARAM_CAT_REGION_CODE_B',
					'PARAM_CAT_REGION_CODE_C',
					'PARAM_CAT_REGION_DESCRIPTION',
					'PARAM_CAT_REGION_DESCRIPTION_B',
					'PARAM_CAT_REGION_DESCRIPTION_C',
					'PARAM_CAT_REGION_STATUS',
					'PARAM_CAT_REGION_SYSTEM_GENERATED',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_CAT_REGION_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_REGION_ID');
			$PARAM_CAT_REGION_GLOBAL_ID = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_GLOBAL_ID');
			$PARAM_CAT_REGION_CAT_COUNTRY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_REGION_CAT_COUNTRY_ID');
			$PARAM_CAT_REGION_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_CODE');
			$PARAM_CAT_REGION_CODE_B = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_CODE_B');
			$PARAM_CAT_REGION_CODE_C = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_CODE_C');
			$PARAM_CAT_REGION_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_DESCRIPTION');
			$PARAM_CAT_REGION_DESCRIPTION_B = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_DESCRIPTION_B');
			$PARAM_CAT_REGION_DESCRIPTION_C = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_REGION_DESCRIPTION_C');
			$PARAM_CAT_REGION_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_REGION_STATUS');
			$PARAM_CAT_REGION_SYSTEM_GENERATED = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_REGION_SYSTEM_GENERATED');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'CAT_REGION_ID', 
						'CAT_REGION_GLOBAL_ID', 
						'CAT_REGION_CAT_COUNTRY_ID', 
						'CAT_REGION_CODE', 
						'CAT_REGION_CODE_B', 
						'CAT_REGION_CODE_C', 
						'CAT_REGION_DESCRIPTION', 
						'CAT_REGION_DESCRIPTION_B', 
						'CAT_REGION_DESCRIPTION_C', 
						'CAT_REGION_STATUS', 
						'CAT_REGION_SYSTEM_GENERATED'
						, 
						'CAT_COUNTRY_ID',		
						'CAT_COUNTRY_GLOBAL_ID',		
						'CAT_COUNTRY_CODE',		
						'CAT_COUNTRY_CODE_B',		
						'CAT_COUNTRY_CODE_C',		
						'CAT_COUNTRY_DESCRIPTION',		
						'CAT_COUNTRY_DESCRIPTION_B',		
						'CAT_COUNTRY_DESCRIPTION_C',		
						'CAT_COUNTRY_STATUS',		
						'CAT_COUNTRY_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_CATEGORY_ADDRESS_REGION::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_CAT_REGION_ID'] = $PARAM_CAT_REGION_ID;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_GLOBAL_ID'] = $PARAM_CAT_REGION_GLOBAL_ID;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_CAT_COUNTRY_ID'] = $PARAM_CAT_REGION_CAT_COUNTRY_ID;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_CODE'] = $PARAM_CAT_REGION_CODE;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_CODE_B'] = $PARAM_CAT_REGION_CODE_B;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_CODE_C'] = $PARAM_CAT_REGION_CODE_C;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_DESCRIPTION'] = $PARAM_CAT_REGION_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_DESCRIPTION_B'] = $PARAM_CAT_REGION_DESCRIPTION_B;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_DESCRIPTION_C'] = $PARAM_CAT_REGION_DESCRIPTION_C;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_STATUS'] = $PARAM_CAT_REGION_STATUS;
			$GET_MAP_ARRAY['PARAM_CAT_REGION_SYSTEM_GENERATED'] = $PARAM_CAT_REGION_SYSTEM_GENERATED;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_CATEGORY_ADDRESS_REGION::CUS_GET_LITE_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>